function XMLMap()
{
    this.__map = new Object();
}

XMLMap.prototype.get = function(key)
{
    var val = this.__map[key.toString()];
    if (val == undefined) return null;
    return val.toString();
}

XMLMap.prototype.loadFromXML = function(xml, contentType)
{
	var doc = null;
	var d = null;
	var els = null;
	try
	{
		try
		{
			var dom = new DOMParser();
			d = dom.parseFromString(xml,"text/xml");
			els = d.getElementsByTagName('entry');
			delete dom;
		}
		catch(e)
		{
			d = new ActiveXObject("MSXML.DomDocument");
			d.loadXML(xml);
			els = d.selectNodes("//entry");
		}
	}
	catch(e)
	{
		d = null;
	}
	if (d)
	{
		var l = els.length;
		for (var i = 0; i < l; i++)
		{
			//var node = els(i);
			var node = els.item(i);
			var key = node.getAttribute("key");
			this.__map[key] = node.getAttribute("value");
		}
	}
}

XMLMap.prototype.getXMLMap = function()
{
    return this.__map;
}

var imageArrBuf = new Array();
var compArr = new Array();
var exchArr = new Array();
var rid = false;

function ImagePreloader(images, call_back)
{

   // store the call-back
   this.call_back = call_back;
   // initialize internal state.

   this.nLoaded = 0;
   this.nProcessed = 0;
   this.aImages = new Array;

   // record the number of images.
   this.nImages = images.length;

   // for each image, call preload()
   for ( var i = 0; i < images.length; i++ ) 
      this.preload(images[i]);

}


ImagePreloader.prototype.preload = function(image)

{

   // create new Image object and add to array
   var oImage = new Image;
   this.aImages.push(oImage);

   // set up event handlers for the Image object
   oImage.onload = ImagePreloader.prototype.onload;
   oImage.onerror = ImagePreloader.prototype.onerror;
   oImage.onabort = ImagePreloader.prototype.onabort;

   // assign pointer back to this.
   oImage.oImagePreloader = this;
   oImage.bLoaded = false;

   // assign the .src property of the Image object
   oImage.src = image;

}

ImagePreloader.prototype.onComplete = function()

{

   this.nProcessed++;
   if ( this.nProcessed == this.nImages )
   {
      this.call_back(this.aImages, this.nLoaded);
   }

}

ImagePreloader.prototype.onload = function()
{

   this.bLoaded = true;
   this.oImagePreloader.nLoaded++;
   this.oImagePreloader.onComplete();

}

ImagePreloader.prototype.onerror = function()
{

   this.bError = true;
   this.oImagePreloader.onComplete();

}

ImagePreloader.prototype.onabort = function()
{

   this.bAbort = true;
   this.oImagePreloader.onComplete();

}

function onAjaxResponse() 
{
	//alert("1");
    IVX_RT_CHART.parseResponse();
	//alert("2");
}


var xmlhttp;
var imgreq;
var rnd = Math.ceil(Math.random()*1000);

var IVX_RT_CHART = 
{
	ivx_data : Object(),
	AJAX_PROVIDER : "com.iv.rtivx.IVXAjaxProvider",
	xmlhttp: null,
   
	init : function() 
	{
		IVX_RT_CHART.loadData();
	},
   
	sendRequest : function() 
	{
		if  (this.xmlhttp!=null)
			delete xmlhttp;
			
		this.xmlhttp=null;
		try
		{	
			this.xmlhttp=new XMLHttpRequest();
		}
		catch(e)
		{
			this.xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
		}
		if (this.xmlhttp!=null)
		{
			this.xmlhttp.onreadystatechange = onAjaxResponse;
			this.xmlhttp.open("POST","http://ivx.ivolatility.com/ivx/ivx_live.j?"+rnd,true);
			this.xmlhttp.setRequestHeader("ajax_provider",this.AJAX_PROVIDER);
			this.xmlhttp.setRequestHeader("Content-type","text/html");
			this.xmlhttp.send("<root><entry key=\"action\" value=\"get_data\"></entry></root>");  
		}
		else
		{
		}
	},
 
	loadData : function() 
	{
		//alert("caught response");
		IVX_RT_CHART.sendRequest();
		//alert("response processed");
	},
   
	parseResponse: function()
	{
		try
		{
			//alert(this.xmlhttp.status);
			//alert(this.xmlhttp.responseText);
		}
		catch (e)
		{
			//alert("no status");
		}
			if (this.xmlhttp.readyState==4)
			{
				if (this.xmlhttp.status==200)
				{
					//alert("Parse xml");
					var map = new XMLMap();
					map.loadFromXML(this.xmlhttp.responseText,this.xmlhttp.contentType);
					var i = 0;
					if(imageArrBuf.length==0) rid = true;
					var d = new Date();
					for (var key in map.getXMLMap()) 
					{
						//alert("new key in xml");
						var num = key.toString();
						var value = map.get(num);
						if(value!="get_data" && document.getElementById('s'+num))
						{
							var items = value.toString().split(";");
							compArr[num] = items[5];
							exchArr[num] = items[4];
							imageArrBuf[num] = "http://ivx.ivolatility.com/nchart.j?charts=rt_ivx_chart&1=ticker*"+items[0]+",schema*ivx_live&sid="+rnd+"-"+d.getTime();
							document.getElementById('s'+num).innerHTML=items[0];
							document.getElementById('x'+num).innerHTML=items[1];
							document.getElementById('hl'+num).innerHTML=items[3];
							if(parseFloat(items[2]).toString()=="NaN" || parseFloat(items[2])==0) 
							{
								document.getElementById('c'+num).innerHTML=items[2];	
							} else if(parseFloat(items[2]) < 0)
							{
								document.getElementById('c'+num).innerHTML="<span style='color: red;'>"+items[2]+"</span>";
							} else 
							{
								document.getElementById('c'+num).innerHTML="<span style='color: green;'>"+items[2]+"</span>";
							}
							i++;
						} 
					}
					//alert("Image preloader...");
					delete map;
					IVX_RT_CHART.swapImages();
					//var ip = new ImagePreloader(imageArrBuf, IVX_RT_CHART.swapImages);
					//alert("finished parsing xml");
				} else
				{
					window.setTimeout("IVX_RT_CHART.loadData()", 10000);
				}
			}
	},
 
	swapImages : function() 
	{
		if(rid) 
		{
			document.getElementById("comp_name").innerHTML = "<p>"+compArr[0]+"</p>";
			document.getElementById("chart").innerHTML = "";
			var imagesStr = "";
			for(var i=0;i<imageArrBuf.length;i++)
			{
				imagesStr+="<div style='position: absolute;'><img id='myimage"+i+"' style='visibility: hidden;' src='"+imageArrBuf[i]+"' border='0' onerror='this.src=\"images/loading.gif\"'></div>";
			}
			document.getElementById("chart").innerHTML = imagesStr;
			document.getElementById("myimage0").style.visibility="visible";		
		}
		for (var i=0;i<imageArrBuf.length;i++)
		{
			document.getElementById("myimage"+i).src = imageArrBuf[i];
		}
        rid = false;
		window.setTimeout("IVX_RT_CHART.loadData()", 10000);
	},
   
	onError : function(description) 
	{
		window.setTimeout("IVX_RT_CHART.loadData()", 10000);
	}
}

function showChart(obj, mode, num)
{
    if (obj)
    {
		if (mode)
		{
			obj.style.background = "#d1dbed";
			if(num<imageArrBuf.length)
			{
				for(var i=0; i<imageArrBuf.length; i++) 
					if(document.getElementById("myimage"+i)) document.getElementById("myimage"+i).style.visibility = "hidden";
				var obj1 = document.getElementById("myimage"+num); 
				if(obj1)
				{
					obj1.style.visibility = "visible";
					document.getElementById("comp_name").innerHTML = "<p>"+compArr[num]+"</p>";	
				}
			}
		} else
		{
			obj.style.background = "#FFFFFF";
		}
    }
}
  
function writeTableItem(i) 
{
	document.writeln('<tr style="background-color: #FFFFFF;" onmouseover="javascript:showChart(this, true, '+i+')" onmouseout="javascript:showChart(this, false)">');
	document.writeln('<td align="left" width="36"><div id="s'+i+'">&nbsp;</div></td>');
	document.writeln('<td  align="center" width="30" ><div id="x'+i+'">&nbsp;</div></td>');
	document.writeln('<td  align="center" width="30" ><div id="c'+i+'">&nbsp;</div></td>');
	document.writeln('<td  align="center" width="40" ><div id="hl'+i+'">&nbsp;</div></td>');
	document.writeln('</tr>');
}

document.onreadystatechange = function()
{    
    if(document.readyState=="complete")
    {
		alert("!!!!");
    }        
}

